#ifndef __Assembler__
#include	<Assembler.h>
#endif
/*
; CDIconKiller  1994, 1995 Quinn & Peter N Lewis, Fabrizio Oddone
; Written in 4 hours from 02:00 to 05:30 18/June/94

bug fixes, CD driver string in resource (suggested by Quinn),
asm tweaks etc. by Fabrizio Oddone

; Patches GetCatInfo, tests for Custom Icon attribute on
; CD-ROM files/folders, and clears it.

; Detailed description:

; Init time:
;   Find the driver refnum for ".AppleCD" and remeber it.
;   Patch GetCatInfo

; GetCatInfo Patch:
;   Test for GetCatInfo selector on HFSDispatch, do nothing otherwise
;   Call thru
;   Return immediately on error
;   Return immediately unless Custom Icon bit set
;   Walk the volume queue looking for the vrefnum of the GetCatInfo
;   If we don't find it, we leave
;   If we do and the driver refnum matches the CD-ROM driver's refnum, 
;     then clear the custom icon bit
;   Otherwise, we leave

	include	'sysequ.a'
	include	'fsequ.a'
	include	'traps.a'

; procedure ShowIcon (id: integer; delta_x: integer);
	import	ShowIcon
*/
//main	proc	export
extern pascal void ShowIcon(short iconID, short pixels);

#define	patchSize	(43*2)	// because of CodeWarrior asm limitations
#define	HFSDispatchTrapNum	0x60

asm void main(void)
{
	movem.l	a2/d3,-(sp)
	subq.w	#4,sp
	move.w	#128,-(sp)
	_GetString
	move.l	(sp)+,d0
	beq	bad
	move.l	d0,-(sp)
	movea.l	d0,a0
	move.l	(a0),-(sp)

	movea.l	0x11C,a2	// LMGetUTableBase()
	move.w	0x1d2,d3	// LMGetUnitTableEntryCount()
loop:
	move.l	(a2)+,d0
	beq.s	endloop
	movea.l	d0,a1
	
// a1 = curDCtlHndl

	movea.l	(a1),a1
	move.l	/*struct (DCtlEntry.dCtlDriver)*/(a1),d0
	beq.s	endloop
	movea.l	d0,a0
	btst	#6,(struct (DCtlEntry.dCtlFlags)+1)(a1)	// test for RAMDriver
	beq.s	notram
	move.l	(a0),d0
	beq.s	endloop
	movea.l	d0,a0
notram:
	lea	struct (DRVRHeader.drvrName)(a0),a0
	movea.l	(sp),a1
	moveq	#0,d0
	move.b	(a0)+,d0
	swap	d0
	move.b	(a1)+,d0
	_CmpString
	beq.s	found
	
endloop:
	subq.w	#1,d3
	bne	loop
		
	addq.w	#4,sp
	_ReleaseResource
	bra	bad

OurHFSDispatch:
	cmp.w	#9,d0	// Test for GetCatInfo selector
	bne.s	dontdoit
	pea	continued
dontdoit:
	move.l	oldHFSDispatch,-(sp)	// Call thru
	rts

continued:
	tst.w	d0
	bne.s	notstfin	// give up on error
	
	btst	#2,struct (DirInfo.ioDrUsrWds.frFlags)(a0)
	beq.s	fin	// give up unless custom icon
	
	movem.l	a1/d1,-(sp)
	
	movea.l	0x358,a1	// first volume control block LMGetVCBQHdr()+2
	
	move.w	struct (DirInfo.ioVRefNum)(a0),d1
lop:
	cmp.w	struct (VCB.vcbVRefNum)(a1),d1
	bne.s	cont

	move.w	drvrrn,d1
	cmp.w	struct (VCB.vcbDRefNum)(a1),d1
	bne.s	leave
	
	bclr	#2,struct (DirInfo.ioDrUsrWds.frFlags)(a0)	// clear custom icon
	bra	leave
cont:
	movea.l	(a1),a1	// next volume control block
	move.l	a1,d0
	bne.s	lop

leave:
	movem.l	(sp)+,a1/d1
	moveq	#0,d0
	
fin:
	tst.w	d0
notstfin:
	rts

drvrrn:
	dc.w	0
oldHFSDispatch:
	dc.l	0

EndHFSDispatch:

found:
	addq.w	#4,sp
	_ReleaseResource
	sub.w	0x1d2,d3	// calc driver refnum -(unit num+1) LMGetUnitTableEntryCount()
	subq.w	#1,d3
	lea	drvrrn,a0
	move.w	d3,(a0)
	
	moveq	#HFSDispatchTrapNum,d0	// patch HFSDispatch
	_GetOSTrapAddress
	lea	oldHFSDispatch,a1
	move.l	a0,(a1)

//	move.l	#(EndHFSDispatch-OurHFSDispatch),d0
	moveq	#patchSize,d0
	_NewPtrSys
//	move.l	a0,d1
	bne.s	bad
	
//	movea.l	a0,a2
	
	movea.l	a0,a1
	lea	OurHFSDispatch,a0
	moveq	#patchSize,d0
//	move.l	#(EndHFSDispatch-OurHFSDispatch),d0
	_BlockMove

	moveq	#HFSDispatchTrapNum,d0
	movea.l	a1,a0
	_SetOSTrapAddress	

	MOVE.L	#0x230080,-(SP)
	JSR	ShowIcon
//	ShowIcon(0x80, 0x23)
//	bra.s	done
	
bad:


done:
	movem.l	(sp)+,a2/d3
	rts

//	string	pascal

}
//	endp
	
//	end
	
/*
asm -wb "{active}"
(evaluate "{active}" =~ "/(?*:)1(?*)/" )> dev:null
(evaluate "{active}" =~ "/(?*)2.a/" )> dev:null
link -rt INIT=128 -ra =ressysheap,reslocked -t INIT -c CDik -o "{2}" "{active}.o" "{1}ShowIcon.o"
setfile -a B "{2}"



dumpobj "{1}SHOWICON.o"
*/
